﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace WoL_Sample
{
    class Program
    {
        static byte[] ConvertStringToByteArray(string macAddress)
        {
            // Regex to replace "-" and ":" in MAC-Address
            Regex regex = new Regex("[-|:|.]");
            string mac = regex.Replace(macAddress, "");
            // Build the byte-array
            byte[] bytes = new byte[mac.Length / 2];
            // Convert the MAC-Address into byte and fill it...
            for (int i = 0; i < 12; i += 2)
            {
                bytes[i / 2] = Convert.ToByte(mac.Substring(i, 2), 16);
            }
            return bytes;
        }

        static byte[] Create(byte[] mac)
        {
            byte[] packet = new byte[17 * 6];
            for (int i = 0; i < 6; i++)
                packet[i] = 0xFF;

            for (int i = 1; i <= 16; i++)
            {
                for (int j = 0; j < 6; j++)
                    packet[i * 6 + j] = mac[j];
            }
            return packet;
        }

        static void Send(byte[] magicPacket, IPAddress broadcast, int port)
        {
            using (UdpClient udpClient = new UdpClient())
            {
                udpClient.Connect(broadcast, port);
                udpClient.Send(magicPacket, magicPacket.Length);
            }
        }

        static void Main(string[] args)
        {
            Console.Write("Enter MAC: ");
            string macAddress = Console.ReadLine();

            Console.Write("Enter Broadcast: ");
            IPAddress broadcast = IPAddress.Parse(Console.ReadLine());

            int port = 7;
            
            byte[] mac = ConvertStringToByteArray(macAddress);

            byte[] packet = Create(mac);

            Send(packet, broadcast, port);

            Console.WriteLine("Done! Press any key to continue...");
            Console.ReadKey();
        }

    }
}
